export class DecryptionError extends Error {
  public message: string = ''

  constructor(
    public inputError: any
  ) {
    super()

    if (inputError.message.toLowerCase().includes('expected')) {
      this.message = `The decryption key length or format is invalid.`
    } else if (inputError.message.includes('The JWK "alg" member was inconsistent')) {
      this.message = `The decryption key is invalid.`
    } else {
      this.message = inputError.message || 'An error occurred while decrypting file.'
    }

    this.name = 'DecryptionError'
    Object.setPrototypeOf(this, DecryptionError.prototype)
  }
}